SystemOrganization addCategory: #Samgukji2Assist!
SystemOrganization addCategory: 'Samgukji2Assist-GUI'!
SystemOrganization addCategory: 'Samgukji2Assist-Strategy'!

Object subclass: #S2General
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'name intellegence strength charm job province nation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

S2General class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!S2General class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:03'!
name: aString intellegence: anInteger strength: anInteger3 charm: anInteger4 
	^self new
		name: aString;
		intellegence: anInteger;
		strength: anInteger3;
		charm: anInteger4 ! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 16:38'!
beDefender
	self job: (S2DefendingBorder new general: self)! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:04'!
beEasyBackGoverner
	self job: (S2EasyBackGoverner new general: self)! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 16:40'!
beFighter
	self job: (S2Fighting new general: self)! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 21:56'!
beGoverner
	self province governer: self! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 04:15'!
beInProvince: aS2Province
	self removeFromProvince.
	aS2Province addGeneral: self.! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 04:15'!
beInProvinceOfId: anInteger 
	self beInProvince: (nation provinceOfId: anInteger)! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:31'!
beKing
	self nation king: self! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 16:40'!
beScouter
	self job: (S2Scouting new general: self)! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 21:08'!
beUnassigned
	self job: (S2Unassigned new general: self)! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 16:04'!
charm
	^ charm! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:05'!
charm: anInteger 
	charm := anInteger! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 20:47'!
fighterFitness
	^strength * intellegence sqrt sqrt sqrt ! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:12'!
gettersForEquality
	^{#name}! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:09'!
governerFitness
	^charm / strength * intellegence sqrt! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:04'!
intellegence: anInteger 
	intellegence := anInteger! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:57'!
isDefender
	^self job isDefender! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 02:07'!
isDeveloperOrUnassignedGoodDeveloper
	^self job isDevelopingJob or: [ self isUnassigned and: [self isGoodDeveloper] ]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 19:03'!
isFighter
	^self job isFighter! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 21:59'!
isGonnaBeMovedByProject
	^self nation projects anySatisfy: [ :p| p isGoingToMoveGeneral: self ]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:33'!
isGoodDeveloper
	^intellegence >= 50! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 21:33'!
isGoverner
	^self isKing
		ifTrue: [false]
		ifFalse: 
			[self province isNil
				ifTrue: [ false ]
				ifFalse: [ self province governer == self ]]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:21'!
isGovernerOrKing
	^self isKing or: [ self isGoverner ]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:24'!
isInProvinceWhereItShouldBe
	^self province typeEvaluated isGoodWithJob: self job.! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 22:01'!
isInWrongProvinceAndNotGonnaMove
	^self isInProvinceWhereItShouldBe not and: [ self isGonnaBeMovedByProject not ]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:31'!
isKing
	^self nation king == self! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 22:09'!
isNeitherFighterNorDefender
	^self isDefender not and: [ self isFighter not ]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:56'!
isUnassigned
	^self job isUnassigned! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:53'!
job
	^job setDefault: #jobDefault for: self withSetter: #job:! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:54'!
job: aS2Job
	job := aS2Job! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:54'!
jobDefault
	^S2Unassigned new general: self! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:08'!
name
	^name! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:04'!
name: aString 
	name := aString! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:31'!
nation
	^nation! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:31'!
nation: aS2Recom
	nation := aS2Recom! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:07'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: name.
	aStream nextPut: $).! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:03'!
province
	^province! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:03'!
province: aS2Province
	province := aS2Province! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:13'!
removeFromProvince
	province notNil
		ifTrue: [ self province removeGeneral: self ]! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 19:11'!
strength
	^ strength! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:05'!
strength: anInteger 
	strength := anInteger! !

!S2General methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:15'!
usefullness
	^strength + charm + intellegence! !

Object subclass: #S2GeneralsInNationController
	instanceVariableNames: 'model generalSearchString generalsListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-GUI'!

!S2GeneralsInNationController class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:48'!
on: aS2Nation 
	^self new model: aS2Nation ! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:50'!
generalSearchString
	^ generalSearchString! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:01'!
generalSearchString: aString
	generalSearchString := aString.
	self generalsListModel: nil.
	self changed: #generalSearchString.
	self changed: #generalsListElementAt:.! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:54'!
generalsListElementAt: anInteger 
	^self generalsListModel list at: anInteger ! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:52'!
generalsListIndex
	^self generalsListModel selectionIndex! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:56'!
generalsListIndex: anInteger 
	self generalsListModel selectionIndex: anInteger.
	self changed: #generalsListIndex! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:52'!
generalsListModel
	^generalsListModel setDefault: #generalsListModelDefault for: self withSetter: #generalsListModel:! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:53'!
generalsListModel: aTGListModel 
	generalsListModel := aTGListModel! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:05'!
generalsListModelDefault
	^TGListModel new list: 
		(generalSearchString isEmptyOrNil
			ifTrue: [ self model generals ]
			ifFalse: [ self model generals select: [:each| each name includesSubstring: generalSearchString] ]) asArray! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:54'!
generalsListSize
	^self generalsListModel list size ! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:10'!
inspectSelectedGeneral
	self generalsListModel
		ifHasSelection: [:selGen| selGen inspect ] 
		ifDoesNotHaveSelection: [ self inform: 'No general selected.' ]! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:48'!
model
	^ model! !

!S2GeneralsInNationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:48'!
model: aS2Nation 
	model := aS2Nation! !

Object subclass: #S2Job
	instanceVariableNames: 'general'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

S2Job subclass: #S2DefendingBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:58'!
isDefender
	^true! !

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 22:07'!
isFighter
	^false! !

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:29'!
isGoodToBeInBorderProvince
	^true! !

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:40'!
isGoodToBeInCapitalProvince
	^general isKing or: [false]! !

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 19:55'!
isGoodToBeInEasyBackProvince
	^false! !

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:32'!
isGoodToBeInLoyaltyRaisingProvince
	^false! !

!S2DefendingBorder methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 22:12'!
shortName
	^'defend'! !

S2Job subclass: #S2Developing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

S2Job subclass: #S2EasyBackGoverner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2EasyBackGoverner methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:42'!
isDefender
	^false! !

!S2EasyBackGoverner methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:42'!
isFighter
	^false! !

!S2EasyBackGoverner methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:12'!
isGoodToBeInEasyBackProvince
	^true! !

!S2EasyBackGoverner methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:11'!
shortName
	^'easy back governer'! !

S2Job subclass: #S2Fighting
	instanceVariableNames: 'teamTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:58'!
isDefender
	^false! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 19:03'!
isFighter
	^true! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:28'!
isGoodToBeInBorderProvince
	^true! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 22:32'!
isGoodToBeInCapitalProvince
	^false! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:46'!
isGoodToBeInEasyBackProvince
	^false! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:29'!
isGoodToBeInLoyaltyRaisingProvince
	^false! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:04'!
isGoverner
	^false! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:34'!
isKing
	^false! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 22:12'!
shortName
	^'fight'! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 21:18'!
teamTag
	^teamTag! !

!S2Fighting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 21:18'!
teamTag: anObject
	teamTag := anObject! !

!S2Job methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:52'!
general
	^general! !

!S2Job methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:52'!
general: aS2General
	general := aS2General! !

!S2Job methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 02:08'!
isDevelopingJob
	^false! !

!S2Job methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:59'!
isUnassigned
	^false! !

S2Job subclass: #S2LoyaltyRaisingGoverning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

S2Job subclass: #S2Scouting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:58'!
isDefender
	^false! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 21:11'!
isFighter
	^false! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 00:37'!
isGoodToBeInBorderProvince
	^false! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:36'!
isGoodToBeInCapitalProvince
	^true! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 22:17'!
isGoodToBeInLoyaltyRaisingProvince
	^true! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:04'!
isGoverner
	^false! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 16:57'!
isKing
	^false! !

!S2Scouting methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 01:53'!
shortName
	^'scout'! !

S2Job subclass: #S2Unassigned
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:57'!
isDefender
	^false! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 19:03'!
isFighter
	^false! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:33'!
isGoodToBeInBorderProvince
	^false! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:33'!
isGoodToBeInCapitalProvince
	^true! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:35'!
isGoodToBeInEasyBackProvince
	^true! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:34'!
isGoodToBeInLoyaltyRaisingProvince
	^true! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:03'!
isGoverner
	^false! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 16:58'!
isKing
	^false! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 18:56'!
isUnassigned
	^true! !

!S2Unassigned methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 22:28'!
shortName
	^'unassigned'! !

Object subclass: #S2Nation
	instanceVariableNames: 'generals provinces projects king currentProvince'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 05:47'!
addGeneralWithName: aString intellegence: anInteger strength: anInteger2 charm: anInteger3
	|newbie|
	newbie := S2General new name: aString; intellegence: anInteger; strength: anInteger2; charm: anInteger3.
	self generals add: newbie.
	newbie nation: self.
	^newbie! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 05:48'!
addGeneralWithName: aString intellegence: anInteger strength: anInteger2 charm: anInteger3 inProvinceOfId: anInteger4
	|newbie|
	newbie := self addGeneralWithName: aString intellegence: anInteger strength: anInteger2 charm: anInteger3.
	newbie beInProvinceOfId: anInteger4.
	^newbie! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:07'!
addProject:  aS2Project
	self projects add: aS2Project! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:07'!
addProjectGoAndBeGovernerWithGeneralName: aString provinceId: anInteger 
	
	self addProject: (S2GoAndBeGovernerProject general: (self generalNamed: aString) province: (self provinceOfId: anInteger))! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 02:38'!
addProjectGotoProvinceWithGeneral: aS2General provinceId: anInteger 
 
	self addProject: (S2GeneralGoToProject general: aS2General province: (self provinceOfId: anInteger))! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 00:24'!
addProjectGotoProvinceWithGeneralName: aString provinceId: anInteger 
	self addProject: (S2GeneralGoToProject general: (self generalNamed: aString) province: (self provinceOfId: anInteger))! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:52'!
addProjectInvadeWithGeneralNames: aCollection rendezvousProvinceId: anInteger targetProvinceId: anInteger3 

	|newProject|
	newProject := S2InvasionProject generals: (aCollection collect: [:each| self generalNamed: each]) rendezvousProvince: (self provinceOfId: anInteger) targetProvinceId: anInteger3.
	newProject nation: self.
	self addProject: newProject! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:22'!
addProvinceAdjacencyWithId: anInteger id: anInteger2 

	(self provinceOfId: anInteger) beAdjacentWithProvince: (self provinceOfId: anInteger2).! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:16'!
addProvinceOfId: anInteger 
	| possiblyNewProvince |
	possiblyNewProvince := S2Province new id: anInteger.
	(self provinces includes: possiblyNewProvince)
		ifFalse: 
			[ self provinces add: possiblyNewProvince.
			possiblyNewProvince nation: self]! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:28'!
addProvinceOfId: anInteger adjacentWithProvinceIds: aCollection 
	|newPro|
	self addProvinceOfId: anInteger.
	newPro := self provinceOfId: anInteger.
	aCollection do: [ :each| newPro beAdjacentWithProvince: (self provinceOfId: each) ]! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:15'!
borderProvinces
	^self provinces select: #isBorderProvince! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:19'!
borderProvincesNeedingDefendingGenerals
	^self borderProvinces select: [ :each| (each defendingGenerals size) < 5 ] ! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:21'!
borderProvincesNeedingFightingGenerals
	^self borderProvinces select: [ :each| (each fightingGenerals size) < 5 ] ! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:18'!
borderProvincesNeedingGenerals
	^self borderProvinces select: [ :each| (each defendingGenerals size) < 5 ] ! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:20'!
currentProvince
	^ currentProvince! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:19'!
currentProvince: aS2Province 
	currentProvince := aS2Province ! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/15/2014 01:56'!
defenders
	^self generals select: [ :each| each isDefender ]! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/15/2014 03:35'!
fighterFitnessSortedGenerals
	^(self generals) asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness)! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/13/2014 21:38'!
fighterFitnessSortedUnassignedGenerals
	^(self unassignedGenerals) asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness)! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/13/2014 21:29'!
fighters
	^generals select: #isFighter! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:13'!
forProvinceId: anInteger setAdjacentProvinceIndices: aCollection 
	(self provinceOfId: anInteger) adjacentProvinces: (Set withAll: (aCollection collect: [ :each| self provinceOfId: each ]))! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:23'!
generalNamed: aString 
	^self generals detect: [ :each | each name = aString ] ! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 21:27'!
generals
	^generals! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2014 21:27'!
generals: aCollection
	generals := aCollection! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/16/2014 02:45'!
generalsInWrongProvince
	^self generals reject: [ :each| each isInProvinceWhereItShouldBe ] ! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/13/2014 21:38'!
governerFitnessSortedUnassignedGenerals
	^(self unassignedGenerals) asSortedCollection: (UnarySortDescriptor descendingBy: #governerFitness)! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 21:42'!
governers
	^(self provinces select: [ :each| each governer notNil ]) collect: [ :each| each governer ]! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:40'!
hasProvinceOfId: anInteger 
	^self provinces anySatisfy: [ :each| each id = anInteger ]! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:18'!
idOfCurrentProvince: anInteger 
	self currentProvince: (self provinceOfId: anInteger)! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:11'!
king
	^king! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:23'!
moveGeneral: aS2General toProvinceOfId: anInteger 
	|p|
	[self currentProvince generals includes: aS2General] assert.
	p := self provinceOfId: anInteger.
	[aS2General province adjacentProvinces includes: p] assert.
	aS2General removeFromProvince.
	p addGeneral: aS2General.! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:12'!
moveGeneralNamed: aString toProvinceOfId: anInteger 

	self moveGeneral: (self generalNamed: aString) toProvinceOfId: anInteger ! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/14/2014 22:32'!
nationlessGenerals
	^generals select: [ :each| each nation isNil ]! !

!S2Nation methodsFor: 'hot' stamp: 'HwaJong 1/17/2014 22:01'!
notGonnaMoveGeneralsInWrongProvince
	^self generals 
		select: [ :each| each isInWrongProvinceAndNotGonnaMove]! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/23/2014 01:52'!
openCharmSortedGeneralsObjectSheet
	| objectSheet |
	objectSheet := ObjectSheet new.
	objectSheet name: 'charmers'.
	objectSheet addColumnWithAspectSymbol: #name.
	objectSheet addColumnWithAspectSymbol: #charm.
	objectSheet addColumn: 'job' aspect: [:each| each job shortName ].
	objectSheet addColumn: 'land' aspect: [:each| each province typeEvaluated shortName ].
	objectSheet addColumn: 'ok' aspect: [:each| each isInProvinceWhereItShouldBe ].
	objectSheet addAllToRowsWithRowIndex: (self generals asSortedCollection: (UnarySortDescriptor descendingBy: #charm)).
	objectSheet openInWindowWithRowHeaders.! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/23/2014 01:53'!
openFighterFitnessSortedGeneralsInCurrentProvinceWithObjectSheet
	| objectSheet |
	objectSheet := ObjectSheet new.
	objectSheet name: 'fighters in ', self currentProvince id printString.
	objectSheet addColumnWithAspectSymbol: #name.
	objectSheet addColumnWithAspectSymbol: #fighterFitness.
	objectSheet addColumn: 'job' aspect: [:each| each job shortName ].
	objectSheet addColumn: 'land' aspect: [:each| each province typeEvaluated shortName ].
	objectSheet addColumn: 'ok' aspect: [:each| each isInProvinceWhereItShouldBe ].
	objectSheet addAllToRowsWithRowIndex: (self currentProvince generals asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness)).
	objectSheet openInWindowWithRowHeaders.! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/23/2014 01:50'!
openFighterFitnessSortedGeneralsObjectSheet
	| objectSheet |
	objectSheet := ObjectSheet new.
	objectSheet name: 'fighters'.
	objectSheet addColumnWithAspectSymbol: #name.
	objectSheet addColumnWithAspectSymbol: #fighterFitness.
	objectSheet addColumn: 'job' aspect: [:each| each job shortName ].
	objectSheet addColumn: 'land' aspect: [:each| each province typeEvaluated shortName ].
	objectSheet addColumn: 'ok' aspect: [:each| each isInProvinceWhereItShouldBe ].
	objectSheet addAllToRowsWithRowIndex: (self generals asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness)).
	objectSheet openInWindowWithRowHeaders.! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/23/2014 01:53'!
openGovernerFitnessSortedGeneralsInCurrentProvinceWithObjectSheet
	| objectSheet |
	objectSheet := ObjectSheet new.
	objectSheet name: 'governer fitness in ', self currentProvince id printString.
	objectSheet addColumnWithAspectSymbol: #name.
	objectSheet addColumnWithAspectSymbol: #governerFitness.
	objectSheet addColumn: 'job' aspect: [:each| each job shortName ].
	objectSheet addColumn: 'land' aspect: [:each| each province typeEvaluated shortName ].
	objectSheet addColumn: 'ok' aspect: [:each| each isInProvinceWhereItShouldBe ].
	objectSheet addAllToRowsWithRowIndex: (self currentProvince generals asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness)).
	objectSheet openInWindowWithRowHeaders.! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/23/2014 01:53'!
openGovernerFitnessSortedGeneralsObjectSheet
	| objectSheet |
	objectSheet := ObjectSheet new.
	objectSheet name: 'governer fitness'.
	objectSheet addColumnWithAspectSymbol: #name.
	objectSheet addColumnWithAspectSymbol: #governerFitness.
	objectSheet addColumn: 'job' aspect: [:each| each job shortName ].
	objectSheet addColumn: 'land' aspect: [:each| each province typeEvaluated shortName ].
	objectSheet addColumn: 'ok' aspect: [:each| each isInProvinceWhereItShouldBe ].
	objectSheet addAllToRowsWithRowIndex: (self generals asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness)).
	objectSheet openInWindowWithRowHeaders.! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/18/2014 00:24'!
openNotGonnaMoveGeneralsInWrongProvinceObjectSheet
	|sh|
	sh := ObjectSheet new.
	sh name: 'wrong province generals'.
	sh addColumnWithAspectSymbol: #name.
	sh addColumn: 'job' aspect: [:each| each job shortName ].
	sh addColumn: 'prov' aspect: [:each| each province id ].
	sh addColumn: 'prov type' aspect: [:each| each province type shortName ].
	sh addAllToRowsWithRowIndex: self notGonnaMoveGeneralsInWrongProvince.
	sh openInWindowWithRowHeaders.! !

!S2Nation methodsFor: 'object sheet' stamp: 'HwaJong 1/23/2014 02:06'!
openProvincesObjectSheet
	| objectSheet |
	objectSheet := ObjectSheet new.
	objectSheet name: 'Provinces'.
	objectSheet addColumn: 'id' aspect: [:each| each id ].
	objectSheet addColumn: 'type' aspect: [:each| each typeEvaluated shortName ].
	objectSheet addColumn: 'affenders' aspect: [:each| each fightingGenerals size ].
	objectSheet addColumn: 'defenders' aspect: [:each| each defendingGenerals size ].
	objectSheet addColumn: 'developed' aspect: [:each| each developState shortName ].
	objectSheet addColumn: 'GD' aspect: [:each| each generals count: [ :g| g isDeveloperOrUnassignedGoodDeveloper ] ].
	self provinces do: [ :each| objectSheet addRowWithObject: each ].
	objectSheet openInWindowWithoutRowHeaders.! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:49'!
projects
	^projects setDefault: #projectsDefault for: self withSetter: #projects:! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:50'!
projects: aCollection 
	projects := aCollection! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:49'!
projectsDefault
	^Set new! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:57'!
provinceOfId: anInteger 
	^self provinces detect: [ :each| each id = anInteger ]! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/14/2014 16:04'!
provincelessGenerals
	^(generals reject: [ :g| self provinces anySatisfy: [ :p| p generals includes: g ] ]) asSortedCollection: (UnarySortDescriptor descendingBy: #charm)! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:37'!
provinces
	^provinces setDefault: #provincesDefault for: self withSetter: #provinces:! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:38'!
provinces: aCollection 
	provinces := aCollection! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:38'!
provincesDefault
	^Set new! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:44'!
putGeneralsToProvinces
	self shouldBeImplemented.! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:09'!
removeFulfilledProjects
	self projects removeAll: (self projects select: [ :each| each isFulfilled ])! !

!S2Nation methodsFor: 'private' stamp: 'HwaJong 1/15/2014 01:28'!
unassertingMoveGeneral: aS2General toProvinceOfId: anInteger 
	|p|
	p := self provinceOfId: anInteger.
	aS2General removeFromProvince.
	p addGeneral: aS2General.! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/13/2014 21:38'!
unassignedGenerals
	^generals select: #isUnassigned! !

!S2Nation methodsFor: 'select generals' stamp: 'HwaJong 1/14/2014 15:15'!
uselessnessSortedGenerals
	^generals asSortedCollection: (UnarySortDescriptor ascendingBy: #usefullness)! !

!S2Nation methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 22:07'!
whatToDo

	^Array streamContents: 
		[:stream| 
		S2MakeProjectProject new nation: self; putCommandOn: stream ifAtProvince: self currentProvince.
		self projects do: [ :each| each putCommandOn: stream ifAtProvince: self currentProvince ]].! !

Object subclass: #S2NationController
	instanceVariableNames: 'model selectedGeneral provinceListModel generalsOfCurrentProvinceListModel generalSortingListModel whatToDoListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-GUI'!

!S2NationController class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:18'!
on: aS2Nation 
	^self new model: aS2Nation ! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 04:30'!
canBeDone
	^self whatToDoListModel
		ifHasSelection: [:sel| sel  canBeDone ]
		ifDoesNotHaveSelection: [ false ]! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:23'!
currentProvinceDotGeneralListElementAt: anInteger 
	^self generalsOfCurrentProvinceListModel list at: anInteger! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:25'!
currentProvinceDotGeneralListIndex
	^self generalsOfCurrentProvinceListModel selectionIndex! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:24'!
currentProvinceDotGeneralListIndex: anInteger 
	self selectedGeneral: (self generalsOfCurrentProvinceListModel selectionIndex: anInteger).
	self changed: #currentProvinceDotGeneralListIndex! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:23'!
currentProvinceDotGeneralListSize
	^self generalsOfCurrentProvinceListModel list size ! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:03'!
doTheSelectedWork
	self whatToDoListModel selection beDoneWithInteractionWhenExceptionRaised.
	
	self whatToDoListModel: nil.
	self changed: #whatToDoListElementAt:.
	
	self generalsOfCurrentProvinceListModel: nil.
	self changed: #currentProvinceDotGeneralListElementAt:.! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:41'!
generalSortingDropList
	^self generalSortingListModel list! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:44'!
generalSortingDropListIndex
	^self generalSortingListModel selectionIndex! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:00'!
generalSortingDropListIndex: anInteger 
	self generalSortingListModel selectionIndex: anInteger.
	self generalsOfCurrentProvinceListModel: nil.
	self changed: #generalSortingDropListIndex.
	self changed: #currentProvinceDotGeneralListElementAt:! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:42'!
generalSortingListModel
	^generalSortingListModel setDefault: #generalSortingListModelDefault for: self withSetter: #generalSortingListModel:.! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:43'!
generalSortingListModel: aTGListModel 
	generalSortingListModel := aTGListModel! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:20'!
generalSortingListModelDefault
	^TGListModel new list: 
		{
			PrintingDifferently subject: (UnarySortDescriptor ascendingBy: #name) printOnBlockWithSelfWithStream: [:me :stream| stream nextPutAll: '이름 정렬']. 
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #strength) printOnBlockWithSelfWithStream: [:me :stream| stream nextPutAll: '무력 정렬']. 
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #charm) printOnBlockWithSelfWithStream: [:me :stream| stream nextPutAll: '매력 정렬']};
		selectionIndex: 1! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:21'!
generalsOfCurrentProvinceListModel
	^generalsOfCurrentProvinceListModel setDefault: #generalsOfCurrentProvinceListModelDefault for: self withSetter: #generalsOfCurrentProvinceListModel:! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:21'!
generalsOfCurrentProvinceListModel: aTGListModel
	generalsOfCurrentProvinceListModel := aTGListModel! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:59'!
generalsOfCurrentProvinceListModelDefault
	^TGListModel new list: (self model currentProvince generals asSortedCollection: (self generalSortingListModel selection)) asArray! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:32'!
inspectSelectedGeneral
	self generalsOfCurrentProvinceListModel
		ifHasSelection: [:selGen| selGen inspect ] 
		ifDoesNotHaveSelection: [ self inform: 'No general selected.' ]! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:33'!
inspectSelectedProvince

	self provinceListModel
		ifHasSelection: [:selProv| selProv inspect ] 
		ifDoesNotHaveSelection: [ self inform: 'No province selected.' ]! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:31'!
inspectSelectedWork
	self whatToDoListModel selection inspect ! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:20'!
model
	^ model! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:18'!
model: aS2Nation 
	model := aS2Nation! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:18'!
provinceListElementAt: anInteger 
	^self provinceListModel list at:anInteger! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:19'!
provinceListIndex
	"^self model currentProvince 
		ifNil: [ 0 ]
		ifNotNil: [ self provinceListModel list indexOf: self model currentProvince  ]"
	^self provinceListModel selectionIndex! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:33'!
provinceListIndex: anInteger 
	self provinceListModel selectionIndex: anInteger.
	self model currentProvince: (self provinceListModel selection).
	self generalsOfCurrentProvinceListModel: nil.
	self selectedGeneral: nil.
	self whatToDoListModel: nil.
	self changed: #provinceListIndex.
	self changed: #currentProvinceDotGeneralListElementAt:.
	self changed: #whatToDoListElementAt:.! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:16'!
provinceListModel
	^provinceListModel setDefault: #provinceListModelDefault for: self withSetter: #provinceListModel:! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:16'!
provinceListModel: aTGListMdoel
	provinceListModel := aTGListMdoel! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:34'!
provinceListModelDefault
	^TGListModel new list: (self model provinces asSortedCollection: (UnarySortDescriptor ascendingBy: #id)) asArray! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 02:19'!
provinceListSize
	^self provinceListModel list size! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:17'!
refreshProvinceList
	self provinceListModel: nil.
	self changed: #provinceListElementAt: ! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 01:29'!
selectedGeneral: aS2General 
	selectedGeneral := aS2General ! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:32'!
whatToDoListElementAt: anInteger 
	^self whatToDoListModel list at: anInteger ! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:29'!
whatToDoListIndex
	^self whatToDoListModel selectionIndex! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 04:32'!
whatToDoListIndex: anInteger 
	self whatToDoListModel selectionIndex: anInteger.
	self changed: #whatToDoListIndex.
	self changed: #canBeDone.! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:27'!
whatToDoListModel
	^whatToDoListModel setDefault: #whatToDoListModelDefault for: self withSetter: #whatToDoListModel:! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:27'!
whatToDoListModel: aTGListModel
	whatToDoListModel := aTGListModel! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 02:05'!
whatToDoListModelDefault
	^TGListModel new list: (self model whatToDo asSortedCollection: (UnarySortDescriptor ascendingBy: #className))! !

!S2NationController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:29'!
whatToDoListSize
	^self whatToDoListModel list size! !

Object subclass: #S2Project
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

S2Project class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

S2Project subclass: #S2GeneralGoToProject
	instanceVariableNames: 'province general'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2GeneralGoToProject commentStamp: '' prior: 0!
A S2GoAndBeGovernerProject is xxxxxxxxx.

Instance Variables
	general:		<Object>
	province:		<Object>

general
	- xxxxx

province
	- xxxxx
!

!S2GeneralGoToProject class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 00:24'!
general: aS2General province: aS2Province
	^self new
		general: aS2General;
		province: aS2Province! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:55'!
general
	^general! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:55'!
general: aS2General
	general := aS2General! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 00:25'!
gettersForEquality
	^{#province.#general}! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:09'!
isFulfilled
	^general province == province ! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:49'!
isGoingToMoveGeneral: aS2General 
	^aS2General == general and: [ aS2General province ~~ province ] ! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 00:26'!
printOn: aWriteStream	
	aWriteStream nextPut: $(.
	aWriteStream nextPutAll: general name.
	aWriteStream nextPutAll: '를 '.
	aWriteStream print: province id.
	aWriteStream nextPutAll: '로 보내'.
	aWriteStream nextPut: $).! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:55'!
province
	^province! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:55'!
province: aS2Province
	province := aS2Province! !

!S2GeneralGoToProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:06'!
putCommandOn: aWriteStream ifAtProvince: aS2Province 
	(aS2Province generals includes: general) ifTrue: [(aS2Province == province) ifFalse: [" aWriteStream nextPut: 'move general ', general name, ' toward ', province id printString " aWriteStream nextPut: (S2MoveToProvinceWork new general: general; province: province) ] ].! !

S2Project subclass: #S2GoAndBeGovernerProject
	instanceVariableNames: 'province general'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2GoAndBeGovernerProject class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:01'!
general: aS2General province: aS2Province
	^self new
		general: aS2General;
		province: aS2Province! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:53'!
general
	^general! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:53'!
general: aS2General
	general := aS2General! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:51'!
gettersForEquality
	^{#province.#general}! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:11'!
isFulfilled
	^general province == province and: [ general isGoverner ]! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:49'!
printOn: aWriteStream	
	aWriteStream nextPut: $(.
	aWriteStream nextPutAll: general name.
	aWriteStream nextPutAll: '를 '.
	aWriteStream print: province id.
	aWriteStream nextPutAll: '의 태수로 만들어'.
	aWriteStream nextPut: $).! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:53'!
province
	^province! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:54'!
province: aS2Province
	province := aS2Province! !

!S2GoAndBeGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:05'!
putCommandOn: aWriteStream ifAtProvince: aS2Province 
	(S2GeneralGoToProject general: general province: province) putCommandOn: aWriteStream ifAtProvince: aS2Province.
	aS2Province isCapitalProvince
		ifTrue: 
			[(general province == province and: [general isGoverner not]) ifTrue: ["aWriteStream nextPut: 'make ', general name, ' a governer at ', province id printString  "aWriteStream nextPut: (S2LetGovernerWork new general: general)] ]
! !

S2Project subclass: #S2InvasionProject
	instanceVariableNames: 'generals rendezvousProvince targetProvinceId nation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2InvasionProject classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:50'!
generals: aCollection rendezvousProvince: aS2Province targetProvinceId: anInteger 
	^self new
		generals: aCollection;
		rendezvousProvince: aS2Province;
		targetProvinceId: anInteger ! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:51'!
generals
	^ generals! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:50'!
generals: aCollection 
	generals := aCollection! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:51'!
gettersForEquality
	^{#generals. #rendezvousProvince. #targetProvinceId}! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 02:19'!
isFulfilled
	^generals allSatisfy: [ :each| each province id = targetProvinceId ]! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:50'!
isGoingToMoveGeneral: aS2General 
	^(generals includes: aS2General) and: [ aS2General province ~~ rendezvousProvince ] ! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:50'!
nation: aS2Nation
	nation := aS2Nation! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 04:32'!
printOn: aWriteStream	
	aWriteStream nextPut: $(.
	aWriteStream print: (generals collect: #name).
	aWriteStream nextPutAll: '가 '.
	aWriteStream print: rendezvousProvince id.
	aWriteStream nextPutAll: '에 모여'.
	aWriteStream print: targetProvinceId.
	aWriteStream nextPutAll: '를 쳐들어 간다'.
	aWriteStream nextPut: $).! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:53'!
putCommandOn: aWriteStream ifAtProvince: aS2Province 
	generals do: [ :general| (S2GeneralGoToProject general: general province: rendezvousProvince) putCommandOn: aWriteStream ifAtProvince: aS2Province ].
	(aS2Province == rendezvousProvince and: [ generals allSatisfy: [ :gen| gen province == rendezvousProvince ] ])
		ifTrue: [ aWriteStream nextPut: (S2InvasionWork new generals: generals; targetProvinceId: targetProvinceId; project: self) ]
	! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:51'!
rendezvousProvince
	^ rendezvousProvince! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:50'!
rendezvousProvince: aS2Province 
	rendezvousProvince := aS2Province! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:52'!
targetProvinceId
	^ targetProvinceId! !

!S2InvasionProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:51'!
targetProvinceId: anInteger 
	targetProvinceId := anInteger! !

S2Project subclass: #S2LetGovernerProject
	instanceVariableNames: 'general'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2LetGovernerProject commentStamp: '' prior: 0!
A S2GoAndBeGovernerProject is xxxxxxxxx.

Instance Variables
	general:		<Object>
	province:		<Object>

general
	- xxxxx

province
	- xxxxx
!

!S2LetGovernerProject class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:41'!
general: aS2General province: aS2Province
	^self new
		general: aS2General;
		province: aS2Province! !

!S2LetGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:41'!
general
	^general! !

!S2LetGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:41'!
general: aS2General
	general := aS2General! !

!S2LetGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:42'!
gettersForEquality
	^{#general}! !

!S2LetGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:43'!
printOn: aWriteStream	
	aWriteStream nextPut: $(.
	aWriteStream nextPutAll: general name.
	aWriteStream nextPutAll: '를 태수로 만들어'.
	aWriteStream nextPut: $).! !

!S2LetGovernerProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:02'!
putCommandOn: aWriteStream ifAtProvince: aS2Province 

	aS2Province isCapitalProvince
		ifTrue: 
			[(general isGoverner not) ifTrue: [aWriteStream nextPut: (S2NotFunctioningTextWork new string: ('make ', general name, ' a governer at ', general province id printString))  ] ]
! !

S2Project subclass: #S2LureGeneralProject
	instanceVariableNames: 'provinceId generalName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2LureGeneralProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:54'!
generalName: aString
	generalName := aString! !

!S2LureGeneralProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:54'!
provinceId: anInteger
	provinceId := anInteger! !

S2Project subclass: #S2MakeProjectProject
	instanceVariableNames: 'nation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2MakeProjectProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 22:07'!
nation: aS2Nation 
	nation  := aS2Nation! !

!S2MakeProjectProject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:03'!
putCommandOn: aWriteStream ifAtProvince: aS2Province 
	(aS2Province generals select: #isInWrongProvinceAndNotGonnaMove)
		do: [ :each| aWriteStream nextPut: (S2NotFunctioningTextWork new string: ('make project for ', each name)) ]  
		! !

Object subclass: #S2Province
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'id generals displayedGenerals governer adjacentProvinces nation type developState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

S2Province class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!S2Province class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:39'!
id: anInteger 
	^self new id: anInteger! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 22:19'!
addGeneral: aS2General 
	|sizeBefore|
	sizeBefore := self generals size.
	self generals add: aS2General.
	self generals size > sizeBefore
		ifTrue: [ self displayedGenerals addLast: aS2General ].
	aS2General province: self.
	aS2General isKing ifTrue: [ self governer: aS2General ]! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:10'!
adjacentProvinces
	^ adjacentProvinces setDefault: #adjacentProvincesDefault for: self withSetter: #adjacentProvinces:! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:10'!
adjacentProvinces: aCollection 
	adjacentProvinces := aCollection! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 23:10'!
adjacentProvincesDefault
	^Set new! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:21'!
beAdjacentWithProvince: aS2Province
	self adjacentProvinces add: aS2Province.
	aS2Province adjacentProvinces add: self.! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:04'!
beBorderProvince
	self type: (S2BorderProvinceType province: self)! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:26'!
beDevelopedProvince
	self developState: (S2DevelopedState new province: self)! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:28'!
beDevelopingProvince
	self developState: (S2DevelopingState new province: self)! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:04'!
beEasyBackProvince
	self type: (S2EasyBackProvinceType province: self)! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 03:21'!
defenders
	^self generals select: #isDefender! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:18'!
defendingGenerals
	^self generals select: #isDefender! !

!S2Province methodsFor: 'accessing' stamp: 'HwaJong 1/23/2014 01:20'!
developState

	^developState setDefault: #developStateDefault for: self withSetter: #developState:! !

!S2Province methodsFor: 'accessing' stamp: 'HwaJong 1/23/2014 01:20'!
developState: anObject
		
	developState := anObject! !

!S2Province methodsFor: 'defaults' stamp: 'HwaJong 1/23/2014 01:23'!
developStateDefault

	^S2UnknownDevelopState new province: self! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:25'!
developStateIsUnknown
	^self developState isUnknownDevelopState ! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:07'!
displayedGenerals
	^ displayedGenerals setDefault: #displayedGeneralsDefault for: self withSetter: #displayedGenerals:! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 16:58'!
displayedGenerals: aCollection 
	displayedGenerals := aCollection ! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:21'!
displayedGeneralsDefault
	^(self generals asSortedCollection: 
			(UnarySortDescriptor 
				descendingBy: [:each| each isGovernerOrKing ifTrue: [1] ifFalse: [0]] 
				descendingBy: #charm) ) asOrderedCollection! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:06'!
fighterFitnessSortedGenerals
	^self generals asSortedCollection: (UnarySortDescriptor descendingBy: #fighterFitness).! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2014 23:21'!
fightingGenerals
	^self generals select: #isFighter ! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:43'!
generals
	^generals setDefault: #generalsDefault for: self withSetter: #generals:! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:43'!
generals: aCollection 
	generals := aCollection! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 16:26'!
generalsDefault
	^OrderedCollection new! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:41'!
gettersForEquality
	^{#id}! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 21:33'!
governer
	^governer! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 21:38'!
governer: aS2General 
	governer := aS2General! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:41'!
id
	^ id! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:39'!
id: anInteger 
	id := anInteger! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 22:04'!
isBorderProvince
	^self type isBorderProvinceType! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:45'!
isCapitalProvince
	^self governer notNil and: [self governer isKing ]! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 02:11'!
isEasyBackProvince
	^self type isEasyBackProvinceType! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:08'!
nation
	^ nation! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 01:08'!
nation: aS2Nation 
	nation := aS2Nation! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 15:41'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream print: id.
	aStream nextPut: $)! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 04:22'!
removeGeneral: aS2General 
	self generals remove: aS2General ifAbsent: [].
	self displayedGenerals remove: aS2General ifAbsent: [].
	aS2General province: nil.
	aS2General == governer
		ifTrue: [ self governer: nil ]! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 17:21'!
sortGeneralsByCharm
	
	self displayedGenerals: 
		((self generals asSortedCollection: 
			(UnarySortDescriptor 
				descendingBy: [:each| each isGovernerOrKing ifTrue: [1] ifFalse: [0]] 
				descendingBy: #charm) ) asOrderedCollection)! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/14/2014 16:26'!
sortGeneralsByStrength! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:44'!
type
	^ type setDefault: #typeDefault for: self withSetter: #type:! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 02:05'!
type: aS2ProvinceType
	type := aS2ProvinceType! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:44'!
typeDefault
	^ S2UnknownType new province: self! !

!S2Province methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:06'!
typeEvaluated

	^self type isBorderProvinceType
		ifTrue: [ self type ]
		ifFalse: 
			[self isCapitalProvince ifTrue: [S2CapitalProvinceType province: self] ifFalse: [(self adjacentProvinces anySatisfy: [:each| each isCapitalProvince ]) ifTrue: [ S2LoyaltyRaisingProvinceType province: self ] ifFalse: [ S2EasyBackProvinceType province: self ] ]]! !

Object subclass: #S2ProvinceDevelopState
	instanceVariableNames: 'province'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

S2ProvinceDevelopState subclass: #S2DevelopedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2DevelopedState methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:56'!
shortName
	^'yes'! !

S2ProvinceDevelopState subclass: #S2DevelopingState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2DevelopingState methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:56'!
shortName
	^'no'! !

!S2ProvinceDevelopState methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:26'!
isUnknownDevelopState
	^false! !

!S2ProvinceDevelopState methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:23'!
province: aS2Province 
	province := aS2Province! !

S2ProvinceDevelopState subclass: #S2UnknownDevelopState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2UnknownDevelopState methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/23/2014 01:25'!
isUnknownDevelopState
	^true! !

Object subclass: #S2ProvinceType
	instanceVariableNames: 'province'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

S2ProvinceType subclass: #S2BorderProvinceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2BorderProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 16:43'!
isBorderProvinceType
	^true! !

!S2BorderProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 02:12'!
isEasyBackProvinceType
	^false! !

!S2BorderProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:28'!
isGoodWithJob: aS2Job 
	^aS2Job isGoodToBeInBorderProvince! !

!S2BorderProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:11'!
shortName
	^'border'! !

S2ProvinceType subclass: #S2CapitalProvinceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2CapitalProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:31'!
isGoodWithJob: aS2Job 
	^aS2Job isGoodToBeInCapitalProvince
! !

!S2CapitalProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:11'!
shortName
	^'capital'! !

S2ProvinceType subclass: #S2EasyBackProvinceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2EasyBackProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 16:43'!
isBorderProvinceType
	^false! !

!S2EasyBackProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 02:12'!
isEasyBackProvinceType
	^true! !

!S2EasyBackProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:35'!
isGoodWithJob: aS2Job
	^aS2Job isGoodToBeInEasyBackProvince 
	! !

!S2EasyBackProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:12'!
shortName
	^'easy back'! !

S2ProvinceType subclass: #S2LoyaltyRaisingProvinceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2LoyaltyRaisingProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:28'!
isGoodWithJob: aS2Job
	^aS2Job isGoodToBeInLoyaltyRaisingProvince! !

!S2LoyaltyRaisingProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:12'!
shortName
	^'loyalty raising'! !

!S2ProvinceType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/16/2014 02:03'!
province: aS2Province
	^self new province: aS2Province! !

!S2ProvinceType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2014 02:04'!
province: aS2Province 
	province := aS2Province ! !

S2ProvinceType subclass: #S2UnknownType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Strategy'!

!S2UnknownType methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:44'!
isBorderProvinceType
	^false! !

Object subclass: #S2Work
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

S2Work subclass: #S2InvasionWork
	instanceVariableNames: 'targetProvinceId generals project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:50'!
beDone
	| prov |
	project removeFromNation.
	prov := generals anyOne nation provinceOfId: targetProvinceId.
	generals do: [ :each| each beInProvince: prov ]! !

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:41'!
beDoneWithInteractionWhenExceptionRaised
	self beDone! !

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:40'!
canBeDone
	^generals anyOne nation hasProvinceOfId: targetProvinceId! !

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:38'!
generals: aCollection 
	generals := aCollection! !

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:34'!
printOn: aStream

	"'invade ', targetProvinceId printString, ' with ', (generals collect: #name) printString)"
	aStream nextPutAll: ('invade ', targetProvinceId printString, ' with ', (generals collect: #name) printString)! !

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:56'!
project: aS2InvasionProject 
	project := aS2InvasionProject! !

!S2InvasionWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 01:38'!
targetProvinceId: anInteger 
	targetProvinceId := anInteger! !

S2Work subclass: #S2LetGovernerWork
	instanceVariableNames: 'general'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

S2Work subclass: #S2MoveToProvinceWork
	instanceVariableNames: 'general province'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2MoveToProvinceWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 04:01'!
beDone
	(general province adjacentProvinces includes: province)
		ifFalse: [ (CannotMoveGeneralToProvinceSinceItIsNotAdjacent new work: self) signal ].
	general removeFromProvince.
	province addGeneral: general! !

!S2MoveToProvinceWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:59'!
beDoneWithInteractionWhenExceptionRaised
	[self beDone] on: CannotMoveGeneralToProvinceSinceItIsNotAdjacent do: [ :exp|  
		|choices chosen|
		choices := general province adjacentProvinces asSortedCollection: (UnarySortDescriptor ascendingBy: [:each| each id]).
		chosen := UIManager default chooseFrom: (choices collect: [:each| each printString]) values: choices title: 'Province ', province id printString ,' is not reachable directly. Choose a intermediate province.'.
		chosen ifNotNil: 
			[general removeFromProvince.
			chosen addGeneral: general]]! !

!S2MoveToProvinceWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:38'!
canBeDone
	^true! !

!S2MoveToProvinceWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:06'!
general: aS2General 
	general := aS2General! !

!S2MoveToProvinceWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:10'!
printOn: aWriteStream
	aWriteStream nextPut: $(.
	 aWriteStream nextPutAll: 'move general ', general name, ' toward ', province id printString .
	aWriteStream nextPut: $).! !

!S2MoveToProvinceWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:07'!
province: aS2Province 
	province := aS2Province! !

S2Work subclass: #S2NotFunctioningTextWork
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2NotFunctioningTextWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 04:16'!
canBeDone
	^false! !

!S2NotFunctioningTextWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 01:07'!
printOn: aStream

	aStream print: string! !

!S2NotFunctioningTextWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 00:58'!
string
	^string! !

!S2NotFunctioningTextWork methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2014 00:58'!
string: aString
	string := aString! !

Object subclass: #S2WorkSuite
	instanceVariableNames: 'works'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

Object subclass: #S2World
	instanceVariableNames: 'nations provinces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!S2World methodsFor: 'accessing' stamp: 'HwaJong 1/22/2014 23:40'!
nations

	^nations setDefault: #nationsDefault for: self withSetter: #nations:! !

!S2World methodsFor: 'accessing' stamp: 'HwaJong 1/22/2014 23:41'!
nations: anSet
		
	nations := anSet! !

!S2World methodsFor: 'defaults' stamp: 'HwaJong 1/22/2014 23:40'!
nationsDefault

	^Set new! !

!S2World methodsFor: 'accessing' stamp: 'HwaJong 1/23/2014 00:00'!
provinces

	^provinces setDefault: #provincesDefault for: self withSetter: #provinces:! !

!S2World methodsFor: 'accessing' stamp: 'HwaJong 1/23/2014 00:00'!
provinces: anObject
		
	provinces := anObject! !

!S2World methodsFor: 'defaults' stamp: 'HwaJong 1/23/2014 00:00'!
provincesDefault

	^Set new! !

Error subclass: #CannotMoveGeneralToProvinceSinceItIsNotAdjacent
	instanceVariableNames: 'work'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Samgukji2Assist-Samgukji2Assist'!

!CannotMoveGeneralToProvinceSinceItIsNotAdjacent methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2014 03:42'!
work: aS2Work
	work := aS2Work! !
